'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _actions = require('@webdesignio/floorman/actions');

var _selectors = require('@webdesignio/floorman/selectors');

var _sanitizeHtml = require('sanitize-html');

var _sanitizeHtml2 = _interopRequireDefault(_sanitizeHtml);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Inplace = function () {
  function Inplace(props, el) {
    var _this = this;

    _classCallCheck(this, Inplace);

    var store = props.store;

    var propMapper = mapStateToProps();
    var staticProps = Object.assign({}, props, mapDispatchToProps(store.dispatch, props));
    this.mapProps = function (props) {
      return Object.assign({}, propMapper(props.store.getState(), props), staticProps);
    };
    if (el) {
      this.render(staticProps, el);
      store.subscribe(function () {
        return _this.render(staticProps, el);
      });
      el.oninput = this.onInput.bind(this, staticProps);
    }
  }

  _createClass(Inplace, [{
    key: 'onInput',
    value: function onInput(props, e) {
      var value = (0, _sanitizeHtml2.default)(e.target.innerHTML, { allowedTags: [] });
      props.onUpdate(value);
    }
  }, {
    key: 'render',
    value: function render(props, el) {
      var _mapProps = this.mapProps(props);

      var value = _mapProps.value;
      var isEditable = _mapProps.isEditable;
      var innerHTML = _mapProps.innerHTML;

      var realValue = value || innerHTML || '';
      if (!el) return realValue;
      var contenteditable = isEditable ? 'true' : 'false';
      if (el.getAttribute('contenteditable') !== contenteditable) {
        el.setAttribute('contenteditable', contenteditable);
      }
      if (el.innerHTML !== realValue) el.innerHTML = realValue;
    }
  }]);

  return Inplace;
}();

exports.default = Inplace;


function mapStateToProps() {
  var value = (0, _selectors.createValueSelector)();
  return function (state, _ref) {
    var name = _ref.name;
    return {
      isEditable: (0, _selectors.isEditable)(state),
      value: value(state, name) || ''
    };
  };
}

function mapDispatchToProps(dispatch, _ref2) {
  var name = _ref2.name;

  return {
    onUpdate: function onUpdate(value) {
      dispatch((0, _actions.update)(_defineProperty({}, name, value)));
    }
  };
}