'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectToField;

var _reactRedux = require('react-redux');

var _selectors = require('@webdesignio/floorman/selectors');

var _actions = require('@webdesignio/floorman/actions');

var _getDisplayName = require('./lib/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function connectToField() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var defaultName = _ref.defaultName;

  return function (Child) {
    function mapStateToProps() {
      var value = (0, _selectors.createValueSelector)();
      return function (state, _ref2) {
        var _ref2$name = _ref2.name;
        var name = _ref2$name === undefined ? defaultName : _ref2$name;

        if (!name) throw new Error((0, _getDisplayName2.default)(Child) + ': No name given');
        return {
          isEditable: (0, _selectors.isEditable)(state),
          value: value(state, name)
        };
      };
    }

    function mapDispatchToProps(dispatch, _ref3) {
      var _ref3$name = _ref3.name;
      var name = _ref3$name === undefined ? defaultName : _ref3$name;

      return {
        onChange: function onChange(value) {
          dispatch((0, _actions.update)(_defineProperty({}, name, value)));
        }
      };
    }

    return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Child);
  };
}